`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/04/08 13:54:03
// Design Name: 
// Module Name: down_counter
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module down_counter(
    output reg [3:0] out_sec1,
    output reg [3:0] out_sec2,
    output reg [3:0] out_min1,
    output reg [3:0] out_min2,
    output reg LED_ctl,
    input [3:0] load_sec1,
    input [3:0] load_sec2,
    input [3:0] load_min1,
    input [3:0] load_min2,
    input [1:0] state,
    input count_en,
    input switch,
    input clk,
    input rst_n
    );
    reg [3:0] sec1_tmp1;
    reg [3:0] sec1_tmp2;
    reg [3:0] sec1_tmp3;
    reg [3:0] sec2_tmp1;
    reg [3:0] sec2_tmp2;
    reg [3:0] sec2_tmp3;
    reg [3:0] min1_tmp1;
    reg [3:0] min1_tmp2;
    reg [3:0] min1_tmp3;
    reg [3:0] min2_tmp1;
    reg [3:0] min2_tmp2;
    reg [3:0] min2_tmp3;
    reg borrow1;
    reg borrow2;
    reg borrow3;
    
    always@*
    begin
        sec1_tmp1 = out_sec1;
        sec1_tmp2 = out_sec1 - 1'b1;
        sec2_tmp1 = out_sec2;
        sec2_tmp2 = out_sec2 - 1'b1;
        min1_tmp1 = out_min1;
        min1_tmp2 = out_min1 - 1'b1;
        min2_tmp1 = out_min2;
        min2_tmp2 = out_min2 - 1'b1;
    end
    
    always@*
    if(out_sec1 == 4'b0000 && out_sec2 == 4'b0000 && out_min1 == 4'b0000 && out_min2 == 4'b0000)
        LED_ctl = 1'b1;
    else
        LED_ctl = 1'b0;
//sec1        
    always@*
    if(~(state == 2'b10) && switch == 0)
        if(out_sec1 == 4'b0000 && count_en)
            if(out_sec2 == 4'b0000 && out_min1 == 4'b0000 && out_min2 == 4'b0000)
            begin
                sec1_tmp3 = 4'b0000;
                borrow1 = 1'b0;
            end
            else
            begin
                sec1_tmp3 = 4'b1001;
                borrow1 = 1'b1;
            end
        else if(count_en)
        begin
            sec1_tmp3 = sec1_tmp2;
            borrow1 = 1'b0;
        end
        else
        begin
            sec1_tmp3 = sec1_tmp1;
            borrow1 = 1'b0;
        end
    else
    begin
        sec1_tmp3 = load_sec1;
        borrow1 = 1'b0;
    end
//sec2
    always@*
    if(~(state == 2'b10) && switch == 0)
        if(out_sec2 == 4'b0000 && borrow1)
            if(out_min1 == 4'b0000 && out_min2 == 4'b0000)
            begin
                sec2_tmp3 = 4'b0000;
                borrow2 = 1'b0;
            end
            else
            begin
                sec2_tmp3 = 4'b0101;
                borrow2 = 1'b1;
            end
        else if(borrow1)
        begin
            sec2_tmp3 = sec2_tmp2;
            borrow2 = 1'b0;
        end
        else
        begin
            sec2_tmp3 = sec2_tmp1;
            borrow2 = 1'b0;
        end
    else
    begin
        sec2_tmp3 = load_sec2;
        borrow2 = 1'b0;
    end
//min1
    always@*
    if(~(state == 2'b10) && switch == 0)
        if(out_min1 == 4'b0000 && borrow2)
            if(out_min2 == 4'b0000)
            begin
                min1_tmp3 = 4'b0000;
                borrow3 = 1'b0;
            end
            else
            begin
                min1_tmp3 = 4'b1001;
                borrow3 = 1'b1;
            end
        else if(borrow2)
        begin
            min1_tmp3 = min1_tmp2;
            borrow3 = 1'b0;
        end
        else
        begin
            min1_tmp3 = min1_tmp1;
            borrow3 = 1'b0;
        end
    else
    begin
        min1_tmp3 = load_min1;
        borrow3 = 1'b0;
    end
//min2
    always@*
    if(~(state == 2'b10) && switch == 0)
        if(out_min2 == 4'b0000 && borrow3)
            min2_tmp3 = 4'b0000;
        else if(borrow3)
            min2_tmp3 = min2_tmp2;
        else
            min2_tmp3 = min2_tmp1;
    else
        min2_tmp3 = load_min2;
   
    always@(posedge clk or negedge rst_n)
    if(~rst_n)
    begin
        out_sec1<=4'b0000;
        out_sec2<=4'b0000;
        out_min1<=4'b0000;
        out_min2<=4'b0000;
    end    
    else
    begin
        out_sec1<=sec1_tmp3;
        out_sec2<=sec2_tmp3;
        out_min1<=min1_tmp3;
        out_min2<=min2_tmp3;
    end
    
endmodule
