`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/04/08 13:59:14
// Design Name: 
// Module Name: fsm
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module fsm(
    output reg count_en,
    output reg [1:0] state,
    input [1:0] signal,
    input switch,
    input clk,
    input rst_n
    );
    reg [1:0] next_state;
    
    always@*
    if(~switch)
    case(state)
    2'b00: //(stop)
        case(signal)
        2'b00:
            begin
                count_en = 1'b0;
                next_state = 2'b00;
            end
        2'b01:
            begin
                count_en = 1'b1;
                next_state = 2'b01;
            end
        2'b10:
            begin
                count_en = 1'b1;
                next_state = 2'b01;
            end
        default:
            begin
                count_en = 1'b0;
                next_state = 2'b00; 
            end
        endcase
    2'b01: //(start)
        case(signal)
        2'b00:
            begin
                count_en = 1'b1;
                next_state = 2'b01;
            end
        2'b01:
            begin
                count_en = 1'b0;
                next_state = 2'b00;
            end
        2'b10:
            begin
                count_en = 1'b0;
                next_state = 2'b10;
            end
        default:
            begin
                count_en = 1'b1;
                next_state = 2'b01; 
            end
        endcase
    2'b10: //(reset)
        case(signal)
        2'b00:
            begin
                count_en = 1'b0;
                next_state = 2'b10;
            end
        2'b01:
            begin
                count_en = 1'b0;
                next_state = 2'b10;
            end
        2'b10:
            begin
                count_en = 1'b1;
                next_state = 2'b01;
            end
        default:
            begin
                count_en = 1'b0;
                next_state = 2'b10; 
            end
        endcase   
    default:
        begin
            count_en = 1'b0;
            next_state = 2'b10; 
        end
    endcase
    else
    begin
        count_en = 1'b0;
        next_state = 2'b10; 
    end
    
    always@(posedge clk or negedge rst_n)
    if(~rst_n)
        state <= 2'b10;
    else
        state <= next_state;
        
endmodule