`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/04/13 17:54:33
// Design Name: 
// Module Name: set
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module set(
    input [1:0] signal,
    input clk,
    input rst_n,
    input switch,
    output reg [3:0] load_sec1,
    output reg [3:0] load_sec2,
    output reg [3:0] load_min1,
    output reg [3:0] load_min2
    );
    reg switch_delay;
    reg [3:0] sec1_tmp;
    reg [3:0] sec2_tmp;
    reg [3:0] min1_tmp;
    reg [3:0] min2_tmp;
    reg carry1;
    reg carry2;
    
    always@(posedge clk or negedge rst_n)
    if(~rst_n)
        switch_delay <= 1'b0;
    else
        switch_delay <= switch;
       
    assign up = (~switch_delay) & switch;
//sec1
    always@*
    if(up)
    begin    
        sec1_tmp = 4'b0000;
        carry1 = 1'b0;
    end
    else if(switch && signal[0] && load_sec1 == 4'b1001)
    begin    
        sec1_tmp = 4'b0000;
        carry1 = 1'b1;
    end
    else if(switch && signal[0])
    begin    
        sec1_tmp = load_sec1 + 1'b1;
        carry1 = 1'b0;
    end
    else
    begin    
        sec1_tmp = load_sec1;
        carry1 = 1'b0;
    end
//sec2
    always@*
    if(up)
        sec2_tmp = 4'b0000;
    else if(switch && carry1 && load_sec2 == 4'b0101)
        sec2_tmp = 4'b0000;
    else if(switch && carry1)
        sec2_tmp = load_sec2 + 1'b1;
    else
        sec2_tmp = load_sec2;
//min1
    always@*
    if(up)
    begin    
        min1_tmp = 4'b0000;
        carry2 = 1'b0;
    end
    else if(switch && signal[1] && load_min1 == 4'b1001)
    begin    
        min1_tmp = 4'b0000;
        carry2 = 1'b1;
    end
    else if(switch && signal[1])
    begin    
        min1_tmp = load_min1 + 1'b1;
        carry2 = 1'b0;
    end
    else
    begin    
        min1_tmp = load_min1;
        carry2 = 1'b0;
    end
//min2
    always@*
    if(up)
        min2_tmp = 4'b0000;
    else if(switch && carry2 && load_min2 == 4'b0101)
        min2_tmp = 4'b0000;
    else if(switch && carry2)
        min2_tmp = load_min2 + 1'b1;
    else
        min2_tmp = load_min2;

    always@(posedge clk or negedge rst_n)
    if(~rst_n)
    begin
        load_sec1<=4'b0000;
        load_sec2<=4'b0000; 
        load_min1<=4'b0000; 
        load_min2<=4'b0000; 
    end
    else
    begin
        load_sec1<=sec1_tmp;
        load_sec2<=sec2_tmp; 
        load_min1<=min1_tmp; 
        load_min2<=min2_tmp; 
    end
endmodule
