`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/04/08 16:25:44
// Design Name: 
// Module Name: top_module
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module top_module(
    input clk,
    input rst_n,
    input button1,
    input button2,
    input switch,
    output [7:0] segs,
    output [3:0] ssd_ctl,
    output reg [15:0] LED
    );
    wire [1:0] scan_ctl;
    wire [1:0] signal;
    wire clk_1Hz;
    wire clk_100Hz;
    wire LED_ctl;
    wire [3:0] sec1;
    wire [3:0] sec2;
    wire [3:0] min1;
    wire [3:0] min2;
    wire [3:0] load_sec1;
    wire [3:0] load_sec2;
    wire [3:0] load_min1;
    wire [3:0] load_min2;
    wire count_en;
    wire pb_de1;
    wire pb_de2;
    wire one_pulse1;
    wire one_pulse2;
    wire [1:0] state;
    wire [3:0] ssd_in;
    
    freqdiv U0(.clk(clk),.rst_n(rst_n),.scan_ctl(scan_ctl),.clk_out(clk_1Hz),.clk_100Hz(clk_100Hz));
    down_counter U1(.clk(clk_1Hz),.rst_n(rst_n),.count_en(count_en),.switch(switch),.state(state),.load_sec1(load_sec1),.load_sec2(load_sec2)
                    ,.load_min1(load_min1),.load_min2(load_min2),.out_sec1(sec1),.out_sec2(sec2),.out_min1(min1),.out_min2(min2),.LED_ctl(LED_ctl));
    debounce U2(.clk(clk_100Hz),.rst_n(rst_n),.pb_in(button1),.pb_de(pb_de1));
    debounce U3(.clk(clk_100Hz),.rst_n(rst_n),.pb_in(button2),.pb_de(pb_de2));
    pulse U4(.clk(clk_100Hz),.rst_n(rst_n),.pb_de(pb_de1),.one_pulse(one_pulse1));
    pulse U5(.clk(clk_100Hz),.rst_n(rst_n),.pb_de(pb_de2),.one_pulse(one_pulse2));
    fsm U6(.clk(clk_100Hz),.rst_n(rst_n),.switch(switch),.signal({one_pulse1,one_pulse2}),.count_en(count_en),.state(state));
    set U7(.clk(clk_100Hz),.rst_n(rst_n),.signal({one_pulse1,one_pulse2}),.switch(switch),.load_sec1(load_sec1),.load_sec2(load_sec2),.load_min1(load_min1),.load_min2(load_min2));
    scan_ctl U8(.sec1(sec1),.sec2(sec2),.min1(min1),.min2(min2),.ssd_ctl_en(scan_ctl),.ssd_ctl(ssd_ctl),.ssd_in(ssd_in));
    display U9(.i(ssd_in),.D(segs));
    
    always@*
    if(state == 2'b01)
        LED[0] = 1'b1;
    else
        LED[0] = 1'b0;

    always@*
    if(LED_ctl)
        LED[15:1] = 15'b11111_11111_11111;
    else
        LED[15:1] = 15'b00000_00000_00000;
        
endmodule
